//MyTga.h

#ifndef __MYTGA_H
#define __MYTGA_H

#include <fstream>

#pragma pack(push)
#pragma pack(1)

typedef struct tagTGAHEADER
{
	unsigned char	headerLenght;		// size of the structure
	unsigned char	colorMapType;		// must be equal to 0
	unsigned char	imageType;			// image compression type

	short int		colrmapFirstEntry;	// colormap_origin (toujours 0)
	short int		colormapLength;		// colormap_length (toujours 0)
	unsigned char	colormapSize;		// colormap_size (toujours 0)

	short int		xorigin;			// lower left X coordinate (always 0)
	short int		yorigin;			// lower left Y coordinate (always 0)

	short int		width;				// image width (in pixels)
	short int		height;				// image height (in pixels)

	unsigned char	pixelDepth;			// number of bits per pixel: 16, 24, 32
	unsigned char	imageDescriptor;	// 24 bits = 0x00; 32 bits = 0x80

} TGAHEADER;

#pragma pack(pop)



class MyTga
{
protected:
	//Tga д   о  ְ, ϴ  Ѵ.
	char*		m_pBuff;
	TGAHEADER*	m_pHeader;
	unsigned    char* m_pData;

public:
	MyTga();
	~MyTga();

	bool Load( const char* szFileName);
	bool Save( const char* szFileName);
	void Release();  //MyTga ü ϳ   ٷ궧, Release() ش.
	const TGAHEADER* GetHeader();
	void SetHeader(int bitDepth, int iWidth, int iHeight);
	unsigned char* GetImageData();

protected:
	bool LoadHeader(const char* pBuff);
	bool LoadData(const char* pBuff);

	bool SaveHeader(std::ofstream& file);
	bool SaveData(std::ofstream& file);
};



#endif